// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.15.0
// source: bookings.sql

package database

import (
	"context"
	"database/sql"
	"encoding/json"
	"time"
)

const bookableDayIndex = `-- name: BookableDayIndex :many
SELECT date, house_id, price_id, restriction_reason FROM bookable_days
WHERE house_id = ? AND date >= ? AND date < ?
ORDER BY date ASC
`

type BookableDayIndexParams struct {
	HouseID string
	Start   string
	EndDate string
}

func (q *Queries) BookableDayIndex(ctx context.Context, arg BookableDayIndexParams) ([]BookableDay, error) {
	rows, err := q.db.QueryContext(ctx, bookableDayIndex, arg.HouseID, arg.Start, arg.EndDate)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []BookableDay
	for rows.Next() {
		var i BookableDay
		if err := rows.Scan(
			&i.Date,
			&i.HouseID,
			&i.PriceID,
			&i.RestrictionReason,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const bookableDayIndexUnlimited = `-- name: BookableDayIndexUnlimited :many
SELECT date, house_id, price_id, restriction_reason FROM bookable_days
WHERE house_id = ? AND date >= ?
ORDER BY date ASC
`

type BookableDayIndexUnlimitedParams struct {
	HouseID string
	Start   string
}

func (q *Queries) BookableDayIndexUnlimited(ctx context.Context, arg BookableDayIndexUnlimitedParams) ([]BookableDay, error) {
	rows, err := q.db.QueryContext(ctx, bookableDayIndexUnlimited, arg.HouseID, arg.Start)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []BookableDay
	for rows.Next() {
		var i BookableDay
		if err := rows.Scan(
			&i.Date,
			&i.HouseID,
			&i.PriceID,
			&i.RestrictionReason,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const bookingAdminChargesIndex = `-- name: BookingAdminChargesIndex :many
SELECT id, name FROM charges
WHERE charges.house_id = $1
AND optionality = 'admin'
AND EXISTS (SELECT 1 FROM prices WHERE price_id = charges.price_id AND hidden_at IS NULL)
ORDER BY name ASC
`

type BookingAdminChargesIndexRow struct {
	ID   string
	Name string
}

func (q *Queries) BookingAdminChargesIndex(ctx context.Context, houseID string) ([]BookingAdminChargesIndexRow, error) {
	rows, err := q.db.QueryContext(ctx, bookingAdminChargesIndex, houseID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []BookingAdminChargesIndexRow
	for rows.Next() {
		var i BookingAdminChargesIndexRow
		if err := rows.Scan(&i.ID, &i.Name); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const bookingAdminConfirm = `-- name: BookingAdminConfirm :exec
UPDATE bookings
SET admin_confirmed_at = CURRENT_TIMESTAMP, hashed_token = ?
WHERE id = ? AND cancelled_at IS NULL AND admin_confirmed_at IS NULL
`

type BookingAdminConfirmParams struct {
	HashedToken string
	ID          int32
}

func (q *Queries) BookingAdminConfirm(ctx context.Context, arg BookingAdminConfirmParams) error {
	_, err := q.db.ExecContext(ctx, bookingAdminConfirm, arg.HashedToken, arg.ID)
	return err
}

const bookingAnonymizeCancelled = `-- name: BookingAnonymizeCancelled :many
UPDATE bookings
SET comment = 'Anonymisiert'
WHERE contact <> '' AND cancelled_at IS NOT NULL AND cancelled_at < ?
RETURNING id, house_id, start_at, end_at, people_over, contact, email, phone, comment, invoice, created_at, admin_confirmed_at, user_confirmed_at, cancelled_at, hashed_token, landline
`

func (q *Queries) BookingAnonymizeCancelled(ctx context.Context, cancelledAt sql.NullTime) ([]Booking, error) {
	rows, err := q.db.QueryContext(ctx, bookingAnonymizeCancelled, cancelledAt)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Booking
	for rows.Next() {
		var i Booking
		if err := rows.Scan(
			&i.ID,
			&i.HouseID,
			&i.StartAt,
			&i.EndAt,
			&i.PeopleOver,
			&i.Contact,
			&i.Email,
			&i.Phone,
			&i.Comment,
			&i.Invoice,
			&i.CreatedAt,
			&i.AdminConfirmedAt,
			&i.UserConfirmedAt,
			&i.CancelledAt,
			&i.HashedToken,
			&i.Landline,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const bookingAnonymizeOld = `-- name: BookingAnonymizeOld :many
UPDATE bookings
SET comment = 'Anonymisiert'
WHERE contact <> '' AND end_at < ?
RETURNING id, house_id, start_at, end_at, people_over, contact, email, phone, comment, invoice, created_at, admin_confirmed_at, user_confirmed_at, cancelled_at, hashed_token, landline
`

func (q *Queries) BookingAnonymizeOld(ctx context.Context, endAt time.Time) ([]Booking, error) {
	rows, err := q.db.QueryContext(ctx, bookingAnonymizeOld, endAt)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Booking
	for rows.Next() {
		var i Booking
		if err := rows.Scan(
			&i.ID,
			&i.HouseID,
			&i.StartAt,
			&i.EndAt,
			&i.PeopleOver,
			&i.Contact,
			&i.Email,
			&i.Phone,
			&i.Comment,
			&i.Invoice,
			&i.CreatedAt,
			&i.AdminConfirmedAt,
			&i.UserConfirmedAt,
			&i.CancelledAt,
			&i.HashedToken,
			&i.Landline,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const bookingChargesIndex = `-- name: BookingChargesIndex :many
SELECT id, name, description, house_id, price_id, unit, amount, min_person_charged, charged_over_person_count, exempted_under_age, optionality, created_at, deleted_at FROM charges
WHERE charges.house_id = $1 AND price_id IN (
    SELECT price_id FROM bookable_days
    WHERE bookable_days.house_id = $1 AND date >= $2 AND date < $3
)
ORDER BY price_id, optionality, name ASC
`

type BookingChargesIndexParams struct {
	HouseID string
	Start   string
	EndDate string
}

func (q *Queries) BookingChargesIndex(ctx context.Context, arg BookingChargesIndexParams) ([]Charge, error) {
	rows, err := q.db.QueryContext(ctx, bookingChargesIndex, arg.HouseID, arg.Start, arg.EndDate)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Charge
	for rows.Next() {
		var i Charge
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.Description,
			&i.HouseID,
			&i.PriceID,
			&i.Unit,
			&i.Amount,
			&i.MinPersonCharged,
			&i.ChargedOverPersonCount,
			&i.ExemptedUnderAge,
			&i.Optionality,
			&i.CreatedAt,
			&i.DeletedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const bookingCommentUpdate = `-- name: BookingCommentUpdate :exec
UPDATE bookings
SET comment = ?
WHERE id = ?
`

type BookingCommentUpdateParams struct {
	Comment string
	ID      int32
}

func (q *Queries) BookingCommentUpdate(ctx context.Context, arg BookingCommentUpdateParams) error {
	_, err := q.db.ExecContext(ctx, bookingCommentUpdate, arg.Comment, arg.ID)
	return err
}

const bookingCountForEmail = `-- name: BookingCountForEmail :one
SELECT COUNT(*)
FROM bookings
WHERE email = ? and id <> ? and house_id = ?
AND cancelled_at IS NULL
`

type BookingCountForEmailParams struct {
	Email   string
	ID      int32
	HouseID string
}

func (q *Queries) BookingCountForEmail(ctx context.Context, arg BookingCountForEmailParams) (int64, error) {
	row := q.db.QueryRowContext(ctx, bookingCountForEmail, arg.Email, arg.ID, arg.HouseID)
	var count int64
	err := row.Scan(&count)
	return count, err
}

const bookingCreate = `-- name: BookingCreate :one
INSERT INTO bookings (house_id,  start_at, end_at, people_over, contact, email, phone, landline, comment, invoice)
VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
RETURNING id, house_id, start_at, end_at, people_over, contact, email, phone, comment, invoice, created_at, admin_confirmed_at, user_confirmed_at, cancelled_at, hashed_token, landline
`

type BookingCreateParams struct {
	HouseID    string
	StartAt    time.Time
	EndAt      time.Time
	PeopleOver json.RawMessage
	Contact    string
	Email      string
	Phone      string
	Landline   string
	Comment    string
	Invoice    json.RawMessage
}

func (q *Queries) BookingCreate(ctx context.Context, arg BookingCreateParams) (Booking, error) {
	row := q.db.QueryRowContext(ctx, bookingCreate,
		arg.HouseID,
		arg.StartAt,
		arg.EndAt,
		arg.PeopleOver,
		arg.Contact,
		arg.Email,
		arg.Phone,
		arg.Landline,
		arg.Comment,
		arg.Invoice,
	)
	var i Booking
	err := row.Scan(
		&i.ID,
		&i.HouseID,
		&i.StartAt,
		&i.EndAt,
		&i.PeopleOver,
		&i.Contact,
		&i.Email,
		&i.Phone,
		&i.Comment,
		&i.Invoice,
		&i.CreatedAt,
		&i.AdminConfirmedAt,
		&i.UserConfirmedAt,
		&i.CancelledAt,
		&i.HashedToken,
		&i.Landline,
	)
	return i, err
}

const bookingDelete = `-- name: BookingDelete :exec
UPDATE bookings
SET cancelled_at = CURRENT_TIMESTAMP
WHERE id = ? AND cancelled_at IS NULL
`

func (q *Queries) BookingDelete(ctx context.Context, id int32) error {
	_, err := q.db.ExecContext(ctx, bookingDelete, id)
	return err
}

const bookingEndingAfter = `-- name: BookingEndingAfter :many
SELECT id, house_id, start_at, end_at, people_over, contact, email, phone, comment, invoice, created_at, admin_confirmed_at, user_confirmed_at, cancelled_at, hashed_token, landline FROM bookings
WHERE house_id = ? AND cancelled_at IS NULL AND end_at > ?
ORDER BY start_at
`

type BookingEndingAfterParams struct {
	HouseID string
	EndAt   time.Time
}

func (q *Queries) BookingEndingAfter(ctx context.Context, arg BookingEndingAfterParams) ([]Booking, error) {
	rows, err := q.db.QueryContext(ctx, bookingEndingAfter, arg.HouseID, arg.EndAt)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Booking
	for rows.Next() {
		var i Booking
		if err := rows.Scan(
			&i.ID,
			&i.HouseID,
			&i.StartAt,
			&i.EndAt,
			&i.PeopleOver,
			&i.Contact,
			&i.Email,
			&i.Phone,
			&i.Comment,
			&i.Invoice,
			&i.CreatedAt,
			&i.AdminConfirmedAt,
			&i.UserConfirmedAt,
			&i.CancelledAt,
			&i.HashedToken,
			&i.Landline,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const bookingExpired = `-- name: BookingExpired :many
SELECT id, house_id, start_at, end_at, people_over, contact, email, phone, comment, invoice, created_at, admin_confirmed_at, user_confirmed_at, cancelled_at, hashed_token, landline
FROM bookings
WHERE admin_confirmed_at IS NOT NULL AND user_confirmed_at IS NULL AND cancelled_at IS NULL
AND (admin_confirmed_at < ? OR start_at < ?)
AND house_id = ?
ORDER BY start_at ASC
`

type BookingExpiredParams struct {
	AdminConfirmedAt sql.NullTime
	StartAt          time.Time
	HouseID          string
}

func (q *Queries) BookingExpired(ctx context.Context, arg BookingExpiredParams) ([]Booking, error) {
	rows, err := q.db.QueryContext(ctx, bookingExpired, arg.AdminConfirmedAt, arg.StartAt, arg.HouseID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Booking
	for rows.Next() {
		var i Booking
		if err := rows.Scan(
			&i.ID,
			&i.HouseID,
			&i.StartAt,
			&i.EndAt,
			&i.PeopleOver,
			&i.Contact,
			&i.Email,
			&i.Phone,
			&i.Comment,
			&i.Invoice,
			&i.CreatedAt,
			&i.AdminConfirmedAt,
			&i.UserConfirmedAt,
			&i.CancelledAt,
			&i.HashedToken,
			&i.Landline,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const bookingExtraChargesCreate = `-- name: BookingExtraChargesCreate :exec
INSERT INTO booking_extra_charges (booking_id,  charge_id, percent)
VALUES (?, ?, ?)
`

type BookingExtraChargesCreateParams struct {
	BookingID int32
	ChargeID  string
	Percent   int32
}

func (q *Queries) BookingExtraChargesCreate(ctx context.Context, arg BookingExtraChargesCreateParams) error {
	_, err := q.db.ExecContext(ctx, bookingExtraChargesCreate, arg.BookingID, arg.ChargeID, arg.Percent)
	return err
}

const bookingExtraChargesDelete = `-- name: BookingExtraChargesDelete :exec
DELETE FROM booking_extra_charges
WHERE booking_id = ? AND charge_id = ?
`

type BookingExtraChargesDeleteParams struct {
	BookingID int32
	ChargeID  string
}

func (q *Queries) BookingExtraChargesDelete(ctx context.Context, arg BookingExtraChargesDeleteParams) error {
	_, err := q.db.ExecContext(ctx, bookingExtraChargesDelete, arg.BookingID, arg.ChargeID)
	return err
}

const bookingExtraChargesIndex = `-- name: BookingExtraChargesIndex :many
SELECT booking_id, charge_id, percent FROM booking_extra_charges
WHERE booking_id = ?
`

func (q *Queries) BookingExtraChargesIndex(ctx context.Context, bookingID int32) ([]BookingExtraCharge, error) {
	rows, err := q.db.QueryContext(ctx, bookingExtraChargesIndex, bookingID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []BookingExtraCharge
	for rows.Next() {
		var i BookingExtraCharge
		if err := rows.Scan(&i.BookingID, &i.ChargeID, &i.Percent); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const bookingExtraChargesUpdate = `-- name: BookingExtraChargesUpdate :exec
UPDATE booking_extra_charges
SET percent = ?
WHERE booking_id = ? AND charge_id = ?
`

type BookingExtraChargesUpdateParams struct {
	Percent   int32
	BookingID int32
	ChargeID  string
}

func (q *Queries) BookingExtraChargesUpdate(ctx context.Context, arg BookingExtraChargesUpdateParams) error {
	_, err := q.db.ExecContext(ctx, bookingExtraChargesUpdate, arg.Percent, arg.BookingID, arg.ChargeID)
	return err
}

const bookingFind = `-- name: BookingFind :one
SELECT id, house_id, start_at, end_at, people_over, contact, email, phone, comment, invoice, created_at, admin_confirmed_at, user_confirmed_at, cancelled_at, hashed_token, landline FROM bookings
WHERE id = ?
`

func (q *Queries) BookingFind(ctx context.Context, id int32) (Booking, error) {
	row := q.db.QueryRowContext(ctx, bookingFind, id)
	var i Booking
	err := row.Scan(
		&i.ID,
		&i.HouseID,
		&i.StartAt,
		&i.EndAt,
		&i.PeopleOver,
		&i.Contact,
		&i.Email,
		&i.Phone,
		&i.Comment,
		&i.Invoice,
		&i.CreatedAt,
		&i.AdminConfirmedAt,
		&i.UserConfirmedAt,
		&i.CancelledAt,
		&i.HashedToken,
		&i.Landline,
	)
	return i, err
}

const bookingIndex = `-- name: BookingIndex :many
SELECT bookings.id, bookings.house_id, bookings.start_at, bookings.end_at, bookings.people_over, bookings.contact, bookings.email, bookings.phone, bookings.comment, bookings.invoice, bookings.created_at, bookings.admin_confirmed_at, bookings.user_confirmed_at, bookings.cancelled_at, bookings.hashed_token, bookings.landline, COUNT() OVER() AS total_count
FROM bookings
WHERE bookings.house_id = $1
AND start_at < $2
AND end_at > $3
AND (CASE WHEN $4::string = ''
    THEN 1
    ELSE (
        contact LIKE '%'||($4::string)||'%' COLLATE NOCASE
        OR email LIKE ($4::string) COLLATE NOCASE -- don't add % to email
        OR phone LIKE '%'||($4::string)||'%' COLLATE NOCASE
        OR invoice LIKE '%'||($4::string)||'%' COLLATE NOCASE
    )
END)
AND (
    ($5::bool AND admin_confirmed_at IS NULL AND cancelled_at IS NULL)
    OR ($6::bool AND admin_confirmed_at IS NOT NULL AND user_confirmed_at IS NULL AND cancelled_at IS NULL)
    OR ($7::bool AND user_confirmed_at IS NOT NULL AND cancelled_at IS NULL)
    OR ($8::bool AND cancelled_at IS NOT NULL)
)
AND (CASE WHEN $9::string = ''
    THEN 1
    ELSE (
        EXISTS (SELECT 1 FROM bookable_days WHERE
            bookable_days.house_id = bookings.house_id
            AND bookable_days.price_id = $9::string
            AND date(bookable_days.date, '+1 day') >= bookings.start_at AND bookable_days.date < bookings.end_at
        )
    )
END)
AND (CASE WHEN $10::string = ''
    THEN 1
    ELSE (
        (SELECT COUNT(*) FROM booking_extra_charges WHERE
            booking_extra_charges.booking_id = bookings.id
            AND instr($10::string, booking_extra_charges.charge_id) > 0
        ) >= $11::int --  a bit hacky, but does the job...
    )
END)
ORDER BY start_at ASC
LIMIT $13 OFFSET $12 -- switched in sqlc, no idea why...
`

type BookingIndexParams struct {
	HouseID               string
	StartAt               time.Time
	EndAt                 time.Time
	Search                string
	IncludeUnconfirmed    bool
	IncludeAdminConfirmed bool
	IncludeUserConfirmed  bool
	IncludeCancelled      bool
	PriceID               string
	AdminCharges          string
	AdminChargesCount     int32
	Limit                 int32
	Offset                int32
}

type BookingIndexRow struct {
	ID               int32
	HouseID          string
	StartAt          time.Time
	EndAt            time.Time
	PeopleOver       json.RawMessage
	Contact          string
	Email            string
	Phone            string
	Comment          string
	Invoice          json.RawMessage
	CreatedAt        time.Time
	AdminConfirmedAt sql.NullTime
	UserConfirmedAt  sql.NullTime
	CancelledAt      sql.NullTime
	HashedToken      string
	Landline         string
	TotalCount       int64
}

func (q *Queries) BookingIndex(ctx context.Context, arg BookingIndexParams) ([]BookingIndexRow, error) {
	rows, err := q.db.QueryContext(ctx, bookingIndex,
		arg.HouseID,
		arg.StartAt,
		arg.EndAt,
		arg.Search,
		arg.IncludeUnconfirmed,
		arg.IncludeAdminConfirmed,
		arg.IncludeUserConfirmed,
		arg.IncludeCancelled,
		arg.PriceID,
		arg.AdminCharges,
		arg.AdminChargesCount,
		arg.Limit,
		arg.Offset,
	)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []BookingIndexRow
	for rows.Next() {
		var i BookingIndexRow
		if err := rows.Scan(
			&i.ID,
			&i.HouseID,
			&i.StartAt,
			&i.EndAt,
			&i.PeopleOver,
			&i.Contact,
			&i.Email,
			&i.Phone,
			&i.Comment,
			&i.Invoice,
			&i.CreatedAt,
			&i.AdminConfirmedAt,
			&i.UserConfirmedAt,
			&i.CancelledAt,
			&i.HashedToken,
			&i.Landline,
			&i.TotalCount,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const bookingOverlapping = `-- name: BookingOverlapping :many
SELECT id, house_id, start_at, end_at, people_over, contact, email, phone, comment, invoice, created_at, admin_confirmed_at, user_confirmed_at, cancelled_at, hashed_token, landline FROM bookings
WHERE house_id = $1 AND cancelled_at IS NULL AND
case when start_at > $2
    then ( start_at < $3)
    else ( end_at > $2)
END
ORDER BY start_at
`

type BookingOverlappingParams struct {
	HouseID string
	StartAt time.Time
	EndAt   time.Time
}

func (q *Queries) BookingOverlapping(ctx context.Context, arg BookingOverlappingParams) ([]Booking, error) {
	rows, err := q.db.QueryContext(ctx, bookingOverlapping, arg.HouseID, arg.StartAt, arg.EndAt)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Booking
	for rows.Next() {
		var i Booking
		if err := rows.Scan(
			&i.ID,
			&i.HouseID,
			&i.StartAt,
			&i.EndAt,
			&i.PeopleOver,
			&i.Contact,
			&i.Email,
			&i.Phone,
			&i.Comment,
			&i.Invoice,
			&i.CreatedAt,
			&i.AdminConfirmedAt,
			&i.UserConfirmedAt,
			&i.CancelledAt,
			&i.HashedToken,
			&i.Landline,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const bookingPricesIndex = `-- name: BookingPricesIndex :many
SELECT id, name, created_at, hidden_at FROM prices
WHERE id IN (
    SELECT price_id FROM bookable_days
    WHERE bookable_days.house_id = $1 AND date >= $2 AND date < $3
)
ORDER BY created_at DESC
`

type BookingPricesIndexParams struct {
	HouseID string
	Start   string
	EndDate string
}

func (q *Queries) BookingPricesIndex(ctx context.Context, arg BookingPricesIndexParams) ([]Price, error) {
	rows, err := q.db.QueryContext(ctx, bookingPricesIndex, arg.HouseID, arg.Start, arg.EndDate)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Price
	for rows.Next() {
		var i Price
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.CreatedAt,
			&i.HiddenAt,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const bookingStatusCount = `-- name: BookingStatusCount :many
SELECT (CASE
    WHEN cancelled_at IS NOT NULL THEN 'cancelled'
    WHEN user_confirmed_at IS NOT NULL THEN 'user_confirmed'
    WHEN admin_confirmed_at IS NOT NULL THEN 'admin_confirmed'
    ELSE 'unconfirmed'
END) AS status, COUNT(*)
FROM bookings
WHERE house_id = ?
AND end_at > ?
GROUP BY status
`

type BookingStatusCountParams struct {
	HouseID string
	EndAt   time.Time
}

type BookingStatusCountRow struct {
	Status interface{}
	Count  int64
}

func (q *Queries) BookingStatusCount(ctx context.Context, arg BookingStatusCountParams) ([]BookingStatusCountRow, error) {
	rows, err := q.db.QueryContext(ctx, bookingStatusCount, arg.HouseID, arg.EndAt)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []BookingStatusCountRow
	for rows.Next() {
		var i BookingStatusCountRow
		if err := rows.Scan(&i.Status, &i.Count); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const bookingUpcoming = `-- name: BookingUpcoming :many
SELECT id, house_id, start_at, end_at, people_over, contact, email, phone, comment, invoice, created_at, admin_confirmed_at, user_confirmed_at, cancelled_at, hashed_token, landline
FROM bookings
WHERE house_id = ?
AND cancelled_at IS NULL
AND end_at > ?
ORDER BY start_at ASC
LIMIT 2
`

type BookingUpcomingParams struct {
	HouseID string
	EndAt   time.Time
}

func (q *Queries) BookingUpcoming(ctx context.Context, arg BookingUpcomingParams) ([]Booking, error) {
	rows, err := q.db.QueryContext(ctx, bookingUpcoming, arg.HouseID, arg.EndAt)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Booking
	for rows.Next() {
		var i Booking
		if err := rows.Scan(
			&i.ID,
			&i.HouseID,
			&i.StartAt,
			&i.EndAt,
			&i.PeopleOver,
			&i.Contact,
			&i.Email,
			&i.Phone,
			&i.Comment,
			&i.Invoice,
			&i.CreatedAt,
			&i.AdminConfirmedAt,
			&i.UserConfirmedAt,
			&i.CancelledAt,
			&i.HashedToken,
			&i.Landline,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const bookingUpdateContact = `-- name: BookingUpdateContact :exec
UPDATE bookings
SET contact = ?, email = ?, phone = ?, landline = ?, invoice = ?
WHERE id = ?
`

type BookingUpdateContactParams struct {
	Contact  string
	Email    string
	Phone    string
	Landline string
	Invoice  json.RawMessage
	ID       int32
}

func (q *Queries) BookingUpdateContact(ctx context.Context, arg BookingUpdateContactParams) error {
	_, err := q.db.ExecContext(ctx, bookingUpdateContact,
		arg.Contact,
		arg.Email,
		arg.Phone,
		arg.Landline,
		arg.Invoice,
		arg.ID,
	)
	return err
}

const bookingUpdateDates = `-- name: BookingUpdateDates :exec
UPDATE bookings
SET start_at = ?, end_at = ?
WHERE id = ?
`

type BookingUpdateDatesParams struct {
	StartAt time.Time
	EndAt   time.Time
	ID      int32
}

func (q *Queries) BookingUpdateDates(ctx context.Context, arg BookingUpdateDatesParams) error {
	_, err := q.db.ExecContext(ctx, bookingUpdateDates, arg.StartAt, arg.EndAt, arg.ID)
	return err
}

const bookingUpdatePeopleAges = `-- name: BookingUpdatePeopleAges :exec
UPDATE bookings
SET people_over = ?
WHERE id = ?
`

type BookingUpdatePeopleAgesParams struct {
	PeopleOver json.RawMessage
	ID         int32
}

func (q *Queries) BookingUpdatePeopleAges(ctx context.Context, arg BookingUpdatePeopleAgesParams) error {
	_, err := q.db.ExecContext(ctx, bookingUpdatePeopleAges, arg.PeopleOver, arg.ID)
	return err
}

const bookingUserConfirm = `-- name: BookingUserConfirm :exec
UPDATE bookings
SET user_confirmed_at = CURRENT_TIMESTAMP
WHERE id = ? AND cancelled_at IS NULL AND user_confirmed_at IS NULL AND admin_confirmed_at IS NOT NULL
`

func (q *Queries) BookingUserConfirm(ctx context.Context, id int32) error {
	_, err := q.db.ExecContext(ctx, bookingUserConfirm, id)
	return err
}

const extraRequestsIndex = `-- name: ExtraRequestsIndex :many
SELECT id, weight, house_id, description, pricing
FROM extra_requests
WHERE house_id = ?
ORDER BY weight DESC, id ASC
`

func (q *Queries) ExtraRequestsIndex(ctx context.Context, houseID string) ([]ExtraRequest, error) {
	rows, err := q.db.QueryContext(ctx, extraRequestsIndex, houseID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []ExtraRequest
	for rows.Next() {
		var i ExtraRequest
		if err := rows.Scan(
			&i.ID,
			&i.Weight,
			&i.HouseID,
			&i.Description,
			&i.Pricing,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
